@version 2.7
@warnings
@script generic

/*
#pragma pack(1)
typedef struct st_comData {
	LWItemID item;			// Plugin Owner itemID
	LWItemID itemIDs[2];	// target itemID
	int lineType;			// 0-3(Solid, Dot, Dash, LongDot)
	int isLine;				// 0-1(Draw Line)
	int isFill;				// 0-1(Fill Triangle)
	int isCross;			// 0-1(Draw Center Cross)
	int noPick;				// 0-1(No Pickup)
	int isColor;			// 0-1(UseCostomColor)
	float rgba[4];			// RGBA
} comData;
#pragma pack()
*/

@define CO_COMRING_EVENT_READ		(100)
@define CO_COMRING_EVENT_WRITE		(200)
@define CO_COMRING_TOPIC	"AS_DrawLine"

// struct(dataList)
COData = @"i", "i#2", "i", "i", "i", "i", "i", "i", "f#4"@;

generic{
//debug();
	var curItems = Scene().getSelect();
	if(!curItems) return;
	if(curItems.size() < 3) return;		// test case, require 2 items.

// sample/initial value
	var item    = 0;
	var itemIDs = @0,0@;
	var lineType= 2;
	var isLine  = 1;
	var isFill  = 1;
	var cross   = 1;
	var noPick  = 1;
	var isColor = 0;
	var rgba    = @0.0, 0.0, 0.0, 0.15@;

	comringattach(CO_COMRING_TOPIC, "comringEvent");

// Plugin Owner ID
	item = curItems[3].id;	// first select item

// read
//	datablob = comringencode(COData, item, @0,0@, 0, 0, 0, 0, 0, 0, @0.0,0.0,0.0,0.0@);
	datablob = comringencode(COData, item, itemIDs, lineType, isLine, isFill, cross, noEval, isColor, rgba);
	comringmsg(CO_COMRING_TOPIC, CO_COMRING_EVENT_READ, datablob);

	// (,,,) = fn(); statement isn't suppurt arrayElement. (a[1],a[2],a[3],,,) == NG. (a,b,c,,,) == OK.
	(item, tID1,tID2, lineType, isLine, isFill, cross, noEval, isColor, cR,cG,cB,cA) = comringdecode(COData, datablob);
	itemIDs[1] = tID1; itemIDs[2] = tID2;
	rgba[1]=cR; rgba[2]=cG; rgba[3]=cB; rgba[4]=cA;

// change Param
	itemIDs[1] = curItems[2].id;	// second select item
	itemIDs[2] = curItems[1].id;	// third select item

// write
	datablob = comringencode(COData, item, itemIDs, lineType, isLine, isFill, cross, noEval, isColor, rgba);
	comringmsg(CO_COMRING_TOPIC, CO_COMRING_EVENT_WRITE, datablob);

	comringdetach(CO_COMRING_TOPIC);
}

comringEvent: code, data
{
}
